import { Provider } from '@nestjs/common';
import { PubSubAsyncConfig } from './interfaces/pub-sub-async-config.interface';
import { PubSubOptions } from './interfaces/pub-sub-options.interface';
import { PubSub } from './pub-sub';
import { PUB_SUB_CONFIG_TOKEN } from './pub-sub.constants';
import { getPubSubToken } from './utils/token';

export function createPubSubProvider(options: PubSubOptions): Provider {
  return {
    provide: getPubSubToken(options.name),
    useFactory: () => {
      return new PubSub(options);
    },
  };
}

export function createOptionsProvider(config: PubSubAsyncConfig): Provider {
  return {
    provide: PUB_SUB_CONFIG_TOKEN,
    useFactory: config.useFactory,
    inject: config.inject || [],
  };
}
